/*
 * MAX : devices.h.linuxlab, Fri Nov 29 13:17:26 CET 2002
 * 
 * This is the devices.h configured for linuxlab
 *
 * This file is part of Max data acquisition software
 * Copyright (C) 1998 Christian Rosen
 *
 * Max is free software; you can redistribute it and/or modify it
 * under the terms of the version 2 of GNU General Public License as
 * published by the Free Software Foundation.
 *
 * Max is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License
 * (see the file COPYING) in this directory; if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef DEVICES_H
#define DEVICES_H
#include "list.hh"
#include "sched.hh"

int adc_init   (List *, Scheduler *);
int adc        (List *, Scheduler *);
int adc_pre    (List *, Scheduler *);

int io612_init (List *, Scheduler *);
int io612_pre (List *, Scheduler *);
int io612 (List *, Scheduler *);
int io612_close (List *, Scheduler *);

int hytec640_init (List *, Scheduler *);
int hytec640_pre (List *, Scheduler *);
int hytec640 (List *, Scheduler *);
int hytec640_close (List *, Scheduler *);

int ads1612_init (List *, Scheduler *);
int ads1612_pre (List *, Scheduler *);
int ads1612 (List *, Scheduler *);
int ads1612_close (List *, Scheduler *);

int adc520_init (List *, Scheduler *);
int adc520_pre (List *, Scheduler *);
int adc520 (List *, Scheduler *);
int adc520_close (List *, Scheduler *);

int dsp3016_init (List *, Scheduler *);
int dsp3016_pre (List *, Scheduler *);
int dsp3016 (List *, Scheduler *);
int dsp3016_close (List *, Scheduler *);

int adc2249_init (List *, Scheduler *);
int adc2249_pre (List *, Scheduler *);
int adc2249 (List *, Scheduler *);
int adc2249_close (List *, Scheduler *);

int le2323_init (List *, Scheduler *);
int le2323_pre (List *, Scheduler *);
int le2323 (List *, Scheduler *);
int le2323_close (List *, Scheduler *);

int tr8837_init (List *, Scheduler *);
int tr8837_pre (List *, Scheduler *);
int tr8837 (List *, Scheduler *);
int tr8837_close (List *, Scheduler *);

int sr400_init (List *, Scheduler *);
int sr400_pre (List *, Scheduler *);
int sr400 (List *, Scheduler *);
int sr400_close (List *, Scheduler *);

int sr400new_init (List *, Scheduler *);
int sr400new_pre (List *, Scheduler *);
int sr400new (List *, Scheduler *);
int sr400new_close (List *, Scheduler *);

int tek2712_init (List *, Scheduler *);
int tek2712_pre (List *, Scheduler *);
int tek2712 (List *, Scheduler *);
int tek2712_close (List *, Scheduler *);

/* number of devices without adc */
#define NUMBER_DEVICES 11

int (*Function_List      [NUMBER_DEVICES]) (List *, Scheduler *)  = 
{
io612,
hytec640,
ads1612,
adc520,
dsp3016,
adc2249,
le2323,
tr8837,
sr400,
sr400new,
tek2712
};

int (*Pre_Function_List  [NUMBER_DEVICES]) (List *, Scheduler *)  = 
{
io612_pre,
hytec640_pre,
ads1612_pre,
adc520_pre,
dsp3016_pre,
adc2249_pre,
le2323_pre,
tr8837_pre,
sr400_pre,
sr400new_pre,
tek2712_pre
};

int (*Init_Function_List [NUMBER_DEVICES]) (List *, Scheduler *)  = 
{
io612_init,
hytec640_init,
ads1612_init,
adc520_init,
dsp3016_init,
adc2249_init,
le2323_init,
tr8837_init,
sr400_init,
sr400new_init,
tek2712_init
};

int (*Close_Function_List[NUMBER_DEVICES]) (List *, Scheduler *)  = 
{
io612_close,
hytec640_close,
ads1612_close,
adc520_close,
dsp3016_close,
adc2249_close,
le2323_close,
tr8837_close,
sr400_close,
sr400new_close,
tek2712_close
};

#endif
