/*
 * MAX : gpib.h, Sam Dez 29 19:41:25 CET 2001 -sg
 * 
 * (c) 1998 by C. Rosen, C. Otto, D. Rohloff, M. Dammasch
 * 
 * This file is part of Max data acquisition software
 * Copyright (C) 1997,98 Christian Rosen
 *
 * Max is free software; you can redistribute it and/or modify it
 * under the terms of the version 2 of GNU General Public License as
 * published by the Free Software Foundation.
 *
 * Max is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License
 * (see the file COPYING) in this directory; if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __GPIB_HPP__
#define __GPIB_HPP__

#define GPIB_OK   1
#define GPIB_ERR  0

#define GPIB_STRMAX   255
#define GPIB_NAMEMAX  80

// initflags for gpib_init()
#define IB_IFC   1
#define IB_REM   2
#define IB_CLEAR 4 

//
// Definition of GPIB_Device structure
//
typedef struct {
    int  addr;                   //  Bus-Address of the device
    char name[GPIB_NAMEMAX+1];   //  Name-String of the device (as defined in GPIB.CONF)
    int  stat;                   //  Status of the Device (GPIB_ERR or GPIB_OK)
} GPIB_Device;

//
// function prototypes as defined in GPIB.CPP
//
GPIB_Device  gpib_init ( char *device_name, int initflag );
int  gpib_clear ( GPIB_Device *device );
int  gpib_write ( GPIB_Device *device, char *formatstr, ... );
int  gpib_read ( GPIB_Device *device, char *buffer, unsigned long length );

#endif
